<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Formulario registro automovilístico</title>
    <link href="style.css" rel="stylesheet" type="text/css">
</head>
<body>
    <main>
        <h1> Formulario de registro automovilístico </h1>
        <form action="" class="formulario" id="formulario">
            <center><h4>Debe ingresar correctamente la información del automovil</h4></center>
            <div class="formulario__grupo" id="grupo__codigo">
                <label for="codigo" class="formulario__label">Código</label>
                <div class="formulario__grupo-input">
                    <input type="text" class="formulario__input" name="codigo" id="codigo" placeholder="Ingrese el código del Vehículo" required>
                    <i class="formulario__validacion-v fas fa-times-circle"></i>
                </div>
                <p class="formulario__input-error">Por favor escriba el codigo correctamente </p>
            </div>


            <div class="formulario__grupo" id="grupo__marca">
                <label for="marca" class="formulario__label">Marca</label>
                <div class="formulario__grupo-input">
                    <input type="text" class="formulario__input" name="marca" id="marca" placeholder="Ingrese la marca del vehículo" required>
                    <i class="formulario__validacion-v fas fa-times-circle"></i>
                </div>
                <p class="formulario__input-error">Por favor, escriba bien la marca del vehículo.</p>
            </div>


            <div class="formulario__grupo" id="grupo__modelo">
                <label for="modelo" class="formulario__label">Modelo del vehículo</label>
                <div class="formulario__grupo-input">
                    <input type="text" class="formulario__input" name="modelo" id="modelo" placeholder="Ingrese su nombre" required>
                    <i class="formulario__validacion-v fas fa-times-circle"></i>
                </div>
                <p class="formulario__input-error">Campo alfanumérico no mayor a 30.</p>
                <br>
   
            <div class="formulario__grupo" id="grupo__año">
                <label for="año" class="formulario__label">Año del vehículo</label>
                <div class="formulario__grupo-input">
                    <input type="date" class="formulario__input" name="año" id="año" placeholder="Ingrese el año del vehículo" required>
                    <i class="formulario__validacion-v fas fa-times-circle"></i>
                </div>
                <p class="formulario__input-error">Este campo solo puede contener valores del tipo date.</p>
            </div>
            <br>
            <center>Fecha inicial: <input type="date" name="fechai" required>
                Fecha final: <input type="date" name="fechaf" required></center>

            <div class="formulario__mensaje" id="formulario__mensaje">
                <p><i class="fas fa-exclamation-triangle"></i> <b>Error:</b> Por favor llena el formulario correctamente. </p>
            </div>
            <br>

            <div class="formulario__grupo formulario__grupo-btn-enviar">
                <button type="submit" class="formulario__btn">Enviar</button>
                <p class="formulario__mensaje-exito" id="formulario__mensaje-exito">Su información ha sido registrada exitosamente :)</p>
            </div>
        </form>
    </main>

    <script>
const formulario = document.getElementById('formulario');
const inputs = document.querySelectorAll('#formulario input');

const expresionesRegularesV = {
        codigo: /^[a-zA-Z0-9]{1,5}$/,
        marca: /^[a-zA-Z0-9]{1,50}$/,
        modelo: /^[a-zA-Z0-9]{1,30}$/,
        año: /^\d{1,4}$/,
        fechai: /^\d{4}-\d{2}-\d{2}$/,
        fechaf: /^\d{4}-\d{2}-\d{2}$/
    };

    const campos = {
	codigo: false,
	marca: false,
	modelo: false,
	año: false,
    fechai: false,
	fechaf: false,
}

const validarFormulario = (e) => {
	switch (e.target.name) {
		case "codigo":
			validarCampo(expresiones.codigo, e.target, 'codigo');
		break;
		case "marca":
			validarCampo(expresiones.marca, e.target, 'marca');
		break;
		case "modelo":
			validarCampo(expresiones.modelo, e.target, 'modelo');
		break;
		case "año":
			validarCampo(expresiones.año, e.target, 'año');
		break;
        case "fechai":
			validarCampo(expresiones.fechai, e.target, 'fechai');
		break;
		case "fechaf":
			validarCampo(expresiones.fechaf, e.target, 'fechaf');
		break;
	}
}

const validarCampo = (expresion, input, campo) => {
	if(expresion.test(input.value)){
		document.getElementById(`grupo__${campo}`).classList.remove('formulario__grupo-incorrecto');
		document.getElementById(`grupo__${campo}`).classList.add('formulario__grupo-correcto');
		document.querySelector(`#grupo__${campo} i`).classList.add('fa-check-circle');
		document.querySelector(`#grupo__${campo} i`).classList.remove('fa-times-circle');
		document.querySelector(`#grupo__${campo} .formulario__input-error`).classList.remove('formulario__input-error-activo');
		campos[campo] = true;
	} else {
		document.getElementById(`grupo__${campo}`).classList.add('formulario__grupo-incorrecto');
		document.getElementById(`grupo__${campo}`).classList.remove('formulario__grupo-correcto');
		document.querySelector(`#grupo__${campo} i`).classList.add('fa-times-circle');
		document.querySelector(`#grupo__${campo} i`).classList.remove('fa-check-circle');
		document.querySelector(`#grupo__${campo} .formulario__input-error`).classList.add('formulario__input-error-activo');
		campos[campo] = false;
	}
    
}
        formulario.addEventListener('submit', (e) => {
            e.preventDefault();

	        const terminos = document.getElementById('terminos');
	            if(campos.codigo && campos.marca  && campos.modelo && campos.año && campos.fechai && campos.fechaf ){
		    formulario.reset();

		    document.getElementById('formulario__mensaje-exito').classList.add('formulario__mensaje-exito-activo');
		    setTimeout(() => {
			document.getElementById('formulario__mensaje-exito').classList.remove('formulario__mensaje-exito-activo');
		    }, 5000);

		    document.querySelectorAll('.formulario__grupo-correcto').forEach((icono) => {
			icono.classList.remove('formulario__grupo-correcto');
            
		    });
	    } else {
		    document.getElementById('formulario__mensaje').classList.add('formulario__mensaje-activo');
	    }
    });

    </script>

</body>
</html>